/////////////////////////////////////////////////////////////////////////
///@author ̩֤ȯɷ޹˾
///@file xoms_api_struct.h
///@brief 彻ݽṹ
/////////////////////////////////////////////////////////////////////////
#ifndef _XOMS_API_STRUCT_H_
#define _XOMS_API_STRUCT_H_

#include "xtp_api_data_type.h"
#include "stddef.h"
#include "xtp_api_struct_common.h"

#pragma pack(8)

//=====================ͻ˽ӿڶ=================================
///¶
struct XTPOrderInsertInfo
{
    ///XTPϵͳIDûдXTPϵͳΨһ
    uint64_t                order_xtp_id;
    ///ãɿͻԶ
    uint32_t	            order_client_id;
    ///Լ ͻ󲻴ո'\0'β
    char                    ticker[XTP_TICKER_LEN];
    ///г
    XTP_MARKET_TYPE         market;
    ///۸
    double                  price;
    ///ֶֹۣΣ
    double                  stop_price;
    ///(ƱλΪɣعλΪ)
    int64_t                 quantity;
    ///۸
    XTP_PRICE_TYPE          price_type;
    union{
		///32λֶΣϰ汾apiû
        uint32_t            u32;
        struct {
            ///
            XTP_SIDE_TYPE               side;
            ///ƽ־
            XTP_POSITION_EFFECT_TYPE    position_effect;
			///Ԥֶ1
            uint8_t                     reserved1;
			///Ԥֶ2
			uint8_t                     reserved2;
        };
    };
	///ҵ
	XTP_BUSINESS_TYPE       business_type;
 };


///ʧӦϢ
struct XTPOrderCancelInfo
{
    ///XTPID
    uint64_t                 order_cancel_xtp_id;
    ///ԭʼXTPID
    uint64_t                 order_xtp_id;
};


///Ӧṹ
struct XTPOrderInfo
{
    ///XTPϵͳIDXTPϵͳΨһ
	uint64_t                order_xtp_id;
	///ãûԶ
	uint32_t	            order_client_id;
    ///ãûԶ壨δʹã
    uint32_t                order_cancel_client_id;
    ///XTPϵͳеidXTPϵͳΨһ
    uint64_t                order_cancel_xtp_id;
	///Լ
	char                    ticker[XTP_TICKER_LEN];
	///г
	XTP_MARKET_TYPE         market;
	///۸
	double                  price;
	///˶ı
	int64_t                 quantity;
	///۸
	XTP_PRICE_TYPE          price_type;
    union{
		///32λֶΣϰ汾apiû
        uint32_t            u32;
        struct {
            ///
            XTP_SIDE_TYPE               side;
            ///ƽ־ȨûעֶΣû0
            XTP_POSITION_EFFECT_TYPE    position_effect;
			///Ԥֶ1
			uint8_t                     reserved1;
			///Ԥֶ2
			uint8_t                     reserved2;
        };
    };
	///ҵ
	XTP_BUSINESS_TYPE       business_type;
	///ɽΪ˶ۼƳɽ
	int64_t                 qty_traded;
	///ʣɹʱʾ
	int64_t                 qty_left;
	///ίʱ䣬ʽΪYYYYMMDDHHMMSSsss
	int64_t                 insert_time;
	///޸ʱ䣬ʽΪYYYYMMDDHHMMSSsss
	int64_t                 update_time;
	///ʱ䣬ʽΪYYYYMMDDHHMMSSsss
	int64_t                 cancel_time;
	///ɽΪ˶ĳɽܽ
	double                  trade_amount;
	///ر OMSɵĵţͬorder_xtp_idΪ̵ĵ
	char                    order_local_id[XTP_LOCAL_ORDER_LEN];
	///״̬Ӧûвֳɽ״̬ͣڲѯУвֳɽ״̬
	XTP_ORDER_STATUS_TYPE   order_status;
	///ύ״̬OMSڲʹãûôֳֶͱ
	XTP_ORDER_SUBMIT_STATUS_TYPE   order_submit_status;
	///
	TXTPOrderTypeType       order_type;
};



///ɽṹ
struct XTPTradeReport
{
    ///XTPϵͳID˳ɽرصĶIDXTPϵͳΨһ
    uint64_t                 order_xtp_id;
    ///
    uint32_t                 order_client_id;
    ///Լ
    char                     ticker[XTP_TICKER_LEN];
    ///г
    XTP_MARKET_TYPE          market;
    ///ţXTPID󣬸ֶʵʺorder_xtp_idظӿʱ
    uint64_t                 local_order_id;
    ///ɽţΨһϽÿʽΨһ2ʳɽرӵͬexec_idΪ˱ʽԳɽ
    char                     exec_id[XTP_EXEC_ID_LEN];
    ///۸񣬴˴γɽļ۸
    double                   price;
    ///˴γɽۼ
    int64_t                  quantity;
    ///ɽʱ䣬ʽΪYYYYMMDDHHMMSSsss
    int64_t                  trade_time;
    ///ɽ˴γɽܽ = price*quantity
    double                   trade_amount;
    ///ɽ --ر¼ţڵ˻˵ÿƽ̨ͬƷ֣ΨһϽΨһڶ˻˵Ψһ
    uint64_t                 report_index;
    /// --ţϽΪգдֶ
    char                     order_exch_id[XTP_ORDER_EXCH_LEN];
    ///ɽ  --ɽرеִ
    TXTPTradeTypeType        trade_type;
    union{
		///32λֶΣϰ汾apiû
        uint32_t            u32;
        struct {
            ///
            XTP_SIDE_TYPE               side;
            ///ƽ־
            XTP_POSITION_EFFECT_TYPE    position_effect;
			///Ԥֶ1
			uint8_t                     reserved1;
			///Ԥֶ2
			uint8_t                     reserved2;
        };
    };
	///ҵ
	XTP_BUSINESS_TYPE        business_type;
    ///Ա 
    char                     branch_pbu[XTP_BRANCH_PBU_LEN];
};


//////////////////////////////////////////////////////////////////////////
///ѯ
//////////////////////////////////////////////////////////////////////////
///ѯ-ѯ
struct XTPQueryOrderReq
{
    ///֤ȯ룬ΪգΪգĬϲѯʱڵгɽر
    char      ticker[XTP_TICKER_LEN];
    ///ʽΪYYYYMMDDHHMMSSsssΪ0Ĭϵǰ0
    int64_t   begin_time;
    ///ʽΪYYYYMMDDHHMMSSsssΪ0Ĭϵǰʱ
    int64_t   end_time;  
};

///ѯӦṹ
typedef struct XTPOrderInfo XTPQueryOrderRsp;


///ѯ-ҳѯ
struct XTPQueryOrderByPageReq
{
	///ҪѯĶ
    int64_t         req_count;
	///һյĲѯдǴͷѯ0
    int64_t         reference;
	///ֶ
    int64_t         reserved;
};

//////////////////////////////////////////////////////////////////////////
///ɽرѯ
//////////////////////////////////////////////////////////////////////////
///ѯɽ-ִбŲѯֶΣ
struct XTPQueryReportByExecIdReq
{
    ///XTPϵͳID
    uint64_t  order_xtp_id;  
    ///ɽִб
    char  exec_id[XTP_EXEC_ID_LEN];
};

///ѯɽر-ѯ
struct XTPQueryTraderReq
{
    ///֤ȯ룬ΪգΪգĬϲѯʱڵгɽر
    char      ticker[XTP_TICKER_LEN];
    ///ʼʱ䣬ʽΪYYYYMMDDHHMMSSsssΪ0Ĭϵǰ0
    int64_t   begin_time; 
    ///ʱ䣬ʽΪYYYYMMDDHHMMSSsssΪ0Ĭϵǰʱ
    int64_t   end_time;  
};

///ɽرѯӦṹ
typedef struct XTPTradeReport  XTPQueryTradeRsp;

///ѯɽر-ҳѯ
struct XTPQueryTraderByPageReq
{
	///Ҫѯĳɽر
	int64_t         req_count;
	///һյĲѯɽرдǴͷѯ0
	int64_t         reference;
	///ֶ
	int64_t         reserved;
};

//////////////////////////////////////////////////////////////////////////
///˻ʽѯӦṹ
//////////////////////////////////////////////////////////////////////////
struct XTPQueryAssetRsp
{
    ///ʲֻ˻/Ȩ˻οʽʲ = ʽ + ֤ȯʲĿǰΪ0+ Ԥ۵ʽ𣩣˻οʽʲ = ʽ + ȯʽ + ֤ȯʲ+ Ԥ۵ʽ
    double total_asset;
    ///ʽ
    double buying_power;
    ///֤ȯʲֶΣĿǰΪ0
    double security_asset;
    ///ۼɽ֤ȯռʽ𣨽ֻ˻/Ȩ˻˻ݲã
    double fund_buy_amount;
    ///ۼɽ׷ãֻ˻/Ȩ˻˻ݲã
    double fund_buy_fee;
    ///ۼɽ֤ȯʽ𣨽ֻ˻/Ȩ˻˻ݲã
    double fund_sell_amount;
    ///ۼɽ׷ãֻ˻/Ȩ˻˻ݲã
    double fund_sell_fee;
    ///XTPϵͳԤ۵ʽ𣨰ƱʱԤ۵Ľʽ+Ԥѣ
    double withholding_amount;
    ///˻
    XTP_ACCOUNT_TYPE account_type;

    ///ı֤𣨽Ȩ˻
    double frozen_margin;
    ///Ȩʽ𣨽Ȩ˻
    double frozen_exec_cash;
    ///ȨãȨ˻
    double frozen_exec_fee;
    ///渶ʽ𣨽Ȩ˻
    double pay_later;
    ///Ԥ渶ʽ𣨽Ȩ˻
    double preadva_pay;
    ///Ȩ˻
    double orig_banlance;
    ///ǰȨ˻
    double banlance;
    ///𣨽Ȩ˻
    double deposit_withdraw;
    ///սʽȨ˻
    double trade_netting;
    ///ʽʲȨ˻
    double captial_asset;

    ///ǿʽ𣨽Ȩ˻
    double force_freeze_amount;
    ///ȡʽ𣨽Ȩ˻
    double preferred_amount;

    // ҵֶοʼ1
    ///ȯʽ˻ֻȯȯ
    double repay_stock_aval_banlance;

    // ҵֶν1

    ///ۼƶ
    double fund_order_data_charges;
    ///ۼƳ
    double fund_cancel_data_charges;
    //ͳֶν2

    ///(ֶ)
    uint64_t unknown[43 - 12 - 1 - 2];
};

//////////////////////////////////////////////////////////////////////////
///ѯƱֲṹ
//////////////////////////////////////////////////////////////////////////
struct XTPQueryStkPositionReq
{
    ///֤ȯ
    char                ticker[XTP_TICKER_LEN];
    ///г
    XTP_MARKET_TYPE     market;
};

//////////////////////////////////////////////////////////////////////////
///ѯƱֲ
//////////////////////////////////////////////////////////////////////////
struct XTPQueryStkPositionRsp
{
    ///֤ȯ
    char                ticker[XTP_TICKER_LEN];
    ///֤ȯ
    char                ticker_name[XTP_TICKER_NAME_LEN];
    ///г
    XTP_MARKET_TYPE     market;
    ///ֲܳ
    int64_t             total_qty;
    ///ֲ
    int64_t				sellable_qty;
    ///ֲֳɱ
    double              avg_price;
    ///ӯֶΣ
    double              unrealized_pnl;
    ///ճֲ
    int64_t             yesterday_position;
    ///깺깺ͬʱڣ˿ԹһֶΣ
    int64_t				purchase_redeemable_qty;

	//ΪȨûֶ
    /// ֲַ
	XTP_POSITION_DIRECTION_TYPE      position_direction;
	///ֶ1
	uint32_t			reserved1;
    /// ȨԼ
    int64_t             executable_option;
    /// 
    int64_t             lockable_position;
    /// Ȩ
    int64_t             executable_underlying;
    /// 
    int64_t             locked_position;
    /// 
    int64_t             usable_locked_position;

	//Ϊֻûֶ
    ///ӯɱ
    double             profit_price;
    ///ɱ
    double             buy_cost;
    ///ӯɱ
    double             profit_cost;

    ///(ֶ)
    uint64_t unknown[50 - 9];
};

/////////////////////////////////////////////////////////////////////////
///ûչ֪ͨ
/////////////////////////////////////////////////////////////////////////
struct XTPCreditDebtExtendNotice
{
	uint64_t	xtpid;								///<XTPϵͳIDûдXTPϵͳΨһ
	char		debt_id[XTP_CREDIT_DEBT_ID_LEN];	///<ծԼ
	XTP_DEBT_EXTEND_OPER_STATUS		oper_status;	///<չ״̬
	uint64_t	oper_time;							///<ʱ
};

/////////////////////////////////////////////////////////////////////////
///ʽתˮ֪ͨ
/////////////////////////////////////////////////////////////////////////
struct XTPFundTransferNotice
{
    ///ʽת
    uint64_t	            serial_id;
    ///ת
    XTP_FUND_TRANSFER_TYPE	transfer_type;
    ///
    double	                amount;
    /// 
    XTP_FUND_OPER_STATUS    oper_status;
    ///ʱ
    uint64_t	            transfer_time;
};



/////////////////////////////////////////////////////////////////////////
///ʽתˮѯӦ
/////////////////////////////////////////////////////////////////////////
struct XTPQueryFundTransferLogReq {
    ///ʽת
    uint64_t	serial_id;

};

/////////////////////////////////////////////////////////////////////////
///ʽתˮ¼ṹ
/////////////////////////////////////////////////////////////////////////
typedef struct XTPFundTransferNotice XTPFundTransferLog;

//////////////////////////////////////////////////////////////////////////
///ѯּϢṹ
//////////////////////////////////////////////////////////////////////////
struct XTPQueryStructuredFundInfoReq
{
	XTP_EXCHANGE_TYPE   exchange_id;  ///<룬Ϊ
	char                sf_ticker[XTP_TICKER_LEN];   ///<ּĸ룬ΪգΪգĬϲѯеķּ
};

//////////////////////////////////////////////////////////////////////////
///ѯּϢӦṹ
//////////////////////////////////////////////////////////////////////////
struct XTPStructuredFundInfo
{
    XTP_EXCHANGE_TYPE   exchange_id;  ///<
	char                sf_ticker[XTP_TICKER_LEN];   ///<ּĸ
	char                sf_ticker_name[XTP_TICKER_NAME_LEN]; ///<ּĸ
    char                ticker[XTP_TICKER_LEN];   ///<ּӻ
    char                ticker_name[XTP_TICKER_NAME_LEN]; ///<ּӻ
	XTP_SPLIT_MERGE_STATUS	split_merge_status;   ///<ֺϲ״̬
    uint32_t            ratio; ///<ֺϲ
    uint32_t            min_split_qty;///<С
    uint32_t            min_merge_qty; ///<Сϲ
    double              net_price;///<ֵ
};


//////////////////////////////////////////////////////////////////////////
///ѯƱETFԼ--ṹ,
///Ϊ:1,򷵻гETFԼϢ
///                  2,ֻдmarket,ظýг½
///                   3,дmarketticker,ֻظetfϢ
//////////////////////////////////////////////////////////////////////////
struct XTPQueryETFBaseReq
{
    ///г
    XTP_MARKET_TYPE    market;
    ///ETF
    char               ticker[XTP_TICKER_LEN];
};

//////////////////////////////////////////////////////////////////////////
///ѯƱETFԼ--Ӧṹ
//////////////////////////////////////////////////////////////////////////
typedef struct XTPQueryETFBaseRsp
{
    XTP_MARKET_TYPE     market;                             ///<г
    char                etf[XTP_TICKER_LEN];                ///<etf,,ͳһʹøô
    char                subscribe_redemption_ticker[XTP_TICKER_LEN];    ///<etf깺ش
    int32_t             unit;                               ///<С깺صλӦETF,֤"50ETF"900000
    int32_t             subscribe_status;                   ///<Ƿ깺,1-,0-ֹ
    int32_t             redemption_status;                  ///<Ƿ,1-,0-ֹ
    double              max_cash_ratio;                     ///<ֽ,С1ֵ   TODO Ƿdouble
    double              estimate_amount;                    ///<TԤ
    double              cash_component;                     ///<T-Xֽ
    double              net_value;                          ///<λֵ
    double              total_amount;                       ///<С굥λֵܽ=net_value*unit
}XTPQueryETFBaseRsp;



//////////////////////////////////////////////////////////////////////////
///ѯƱETFԼɷֹϢ--ṹ,Ϊ:г+ETF
//////////////////////////////////////////////////////////////////////////
typedef struct XTPQueryETFComponentReq
{
    ///г
    XTP_MARKET_TYPE     market;
    ///ETF
    char                ticker[XTP_TICKER_LEN];
}XTPQueryETFComponentReq;


//////////////////////////////////////////////////////////////////////////
///ѯƱETFɷֹϢ--Ӧṹ壬ɰ汾
//////////////////////////////////////////////////////////////////////////
struct XTPQueryETFComponentRspV1
{
    ///г
    XTP_MARKET_TYPE     market;
    ///ETF
    char                ticker[XTP_TICKER_LEN];
    ///ɷݹɴ
    char                component_ticker[XTP_TICKER_LEN];
    ///ɷݹ
    char                component_name[XTP_TICKER_NAME_LEN];
    ///ɷݹ
    int64_t             quantity;
    ///ɷݹɽг
    XTP_MARKET_TYPE     component_market;
    ///ɷݹʶ
    ETF_REPLACE_TYPE    replace_type;
    ///۱
    double              premium_ratio;
    ///ɷֹʶΪֽʱܽ
    double              amount;

};

//////////////////////////////////////////////////////////////////////////
///ѯƱETFɷֹϢ--Ӧṹ
//////////////////////////////////////////////////////////////////////////
struct XTPQueryETFComponentRsp
{
    ///г
    XTP_MARKET_TYPE     market;
    ///ETF
    char                ticker[XTP_TICKER_LEN];
    ///ɷݹɴ
    char                component_ticker[XTP_TICKER_LEN];
    ///ɷݹ
    char                component_name[XTP_TICKER_NAME_LEN];
    ///ɷݹ
    int64_t             quantity;
    ///ɷݹɽг
    XTP_MARKET_TYPE     component_market;
    ///ɷݹʶ
    ETF_REPLACE_TYPE    replace_type;
    ///۱
    double              premium_ratio;
    ///ɷֹʶΪֽʱܽ
    double              amount;
    ///깺۱
    double              creation_premium_ratio;
    ///۱
    double              redemption_discount_ratio;
    ///깺ʱɷֹʶΪֽʱܽ
    double              creation_amount;
    ///ʱɷֹʶΪֽʱܽ
    double              redemption_amount;

};

//////////////////////////////////////////////////////////////////////////
///ѯտ깺¹Ϣ
//////////////////////////////////////////////////////////////////////////
struct XTPQueryIPOTickerRsp {
    ///г
    XTP_MARKET_TYPE     market;
    ///깺
    char                ticker[XTP_TICKER_LEN];
    ///깺Ʊ
    char                ticker_name[XTP_TICKER_NAME_LEN]; 
    /// ֤ȯ
    XTP_TICKER_TYPE     ticker_type;
    ///깺۸
    double              price;
    ///깺Ԫ         
    int32_t             unit;
    ///깺
    int32_t             qty_upper_limit;
};



//////////////////////////////////////////////////////////////////////////
///ѯû깺-ɰ
//////////////////////////////////////////////////////////////////////////
struct XTPQueryIPOQuotaRspV1 {
    ///г
    XTP_MARKET_TYPE     market;
    ///깺
    int32_t             quantity;
};


//////////////////////////////////////////////////////////////////////////
///ѯû깺-ҵ
//////////////////////////////////////////////////////////////////////////
struct XTPQueryIPOQuotaRsp {
    ///г
    XTP_MARKET_TYPE     market;
    ///깺
    int32_t             quantity;
    /// Ϻƴ
    int32_t             tech_quantity;
    /// 
    int32_t             unused;
};

//////////////////////////////////////////////////////////////////////////
///걨ûipmacϢȨûʹ
//////////////////////////////////////////////////////////////////////////
struct XTPUserTerminalInfoReq {
	char  local_ip[XTP_INET_ADDRESS_STR_LEN];			///<IPַ
	char  mac_addr[XTP_MAC_ADDRESS_LEN];				///<MACַ
	char  hd[XTP_HARDDISK_SN_LEN];						///<Ӳк
	XTPTerminalType term_type;							///<ն
	char  internet_ip[XTP_INET_ADDRESS_STR_LEN];		///<IPַ
	int32_t internet_port;								///<˿ں
	XTPVersionType  client_version;						///<ͻ˰汾
	char  macos_sno[XTP_MACOS_SNO_LEN];					///<MacOSϵͳкţΪMacOSϵͳҪд
	char  unused[27];									///<Ԥ
};

//////////////////////////////////////////////////////////////////////////
///ѯȨ۽ҵοϢ--ṹ,Ϊ:г+8λȨ
//////////////////////////////////////////////////////////////////////////
struct XTPQueryOptionAuctionInfoReq {
    ///г
    XTP_MARKET_TYPE     market;
    ///8λȨԼ
    char                ticker[XTP_TICKER_LEN];
};

//////////////////////////////////////////////////////////////////////////
///ѯȨ۽ҵοϢ
//////////////////////////////////////////////////////////////////////////
struct XTPQueryOptionAuctionInfoRsp {
    char                ticker[XTP_TICKER_LEN];             ///<Լ룬tickerñֶ
    XTP_MARKET_TYPE     security_id_source;                 ///<֤ȯԴ
    char                symbol[XTP_TICKER_NAME_LEN];        ///<Լ
    char                contract_id[XTP_TICKER_NAME_LEN];   ///<Լ״
    char                underlying_security_id[XTP_TICKER_LEN]; ///<֤ȯ
	XTP_MARKET_TYPE     underlying_security_id_source;      ///<֤ȯԴ

    uint32_t            list_date;                          ///<ڣʽΪYYYYMMDD
    uint32_t            last_trade_date;                    ///<գʽΪYYYYMMDD
    XTP_TICKER_TYPE     ticker_type;                        ///<֤ȯ
    int32_t             day_trading;                        ///<Ƿֵ֧ջתף1-0-

    XTP_OPT_CALL_OR_PUT_TYPE    call_or_put;                ///<ϹϹ
    uint32_t            delivery_day;                       ///<ȨգʽΪYYYYMMDD
    uint32_t            delivery_month;                     ///<·ݣʽΪYYYYMM

    XTP_OPT_EXERCISE_TYPE_TYPE  exercise_type;              ///<Ȩʽ
    uint32_t            exercise_begin_date;                ///<ȨʼڣʽΪYYYYMMDD
    uint32_t            exercise_end_date;                  ///<ȨڣʽΪYYYYMMDD
    double              exercise_price;                     ///<Ȩ۸

    int64_t             qty_unit;                           ///<λĳһ֤ȯ걨ίУίֶαΪ֤ȯλ
    int64_t             contract_unit;                      ///<Լλ
    int64_t             contract_position;                  ///<Լֲ

    double              prev_close_price;                   ///<Լǰ̼
    double              prev_clearing_price;                ///<Լǰ

    int64_t             lmt_buy_max_qty;                    ///<޼
    int64_t             lmt_buy_min_qty;                    ///<޼С
    int64_t             lmt_sell_max_qty;                   ///<޼
    int64_t             lmt_sell_min_qty;                   ///<޼С
    int64_t             mkt_buy_max_qty;                    ///<м
    int64_t             mkt_buy_min_qty;                    ///<мС
    int64_t             mkt_sell_max_qty;                   ///<м
    int64_t             mkt_sell_min_qty;                   ///<мС

    double              price_tick;                         ///<С۵λ
    double              upper_limit_price;                  ///<ͣ
    double              lower_limit_price;                  ///<ͣ
    double              sell_margin;                        ///<ÿű֤
    double              margin_ratio_param1;                ///<֤һ
    double              margin_ratio_param2;                ///<֤

    uint64_t            unknown[20];                        ///<ֶΣ
};

/// ȨϲԳӦṹ
typedef struct XTPOrderCancelInfo XTPOptCombOrderCancelInfo;

/// ȨϲԵĳɷֺԼϢ
struct XTPCombLegStrategy {
    XTP_OPT_CALL_OR_PUT_TYPE    call_or_put;        ///< ԼͣϹϹ
    XTP_POSITION_DIRECTION_TYPE position_side;      ///< Ȩֻֻ򱸶
    TXTPExerciseSeqType         exercise_price_seq; ///< Ȩ˳
    int32_t                     expire_date_seq;    ///< ˳
    int64_t                     leg_qty;            ///< ϲаĴ˺Լ
};

/*/// ȨϲԲѯṹ
typedef struct XTPQueryOptCombineReq
{
	char            strategy_id[XTP_STRATEGY_ID_LEN];	///< ϲԴ
	XTP_MARKET_TYPE market;							    ///< г
}XTPQueryOptCombineReq;
*/
/// ѯȨϲϢӦ
struct XTPQueryCombineStrategyInfoRsp {
    char                    strategy_id[XTP_STRATEGY_ID_LEN];        ///< ϲԴ룬CNSJCPXSJCPNSJCCXSJCKSKKS
    char                    strategy_name[XTP_STRATEGY_NAME_LEN];    ///< ϲƣϹţм۲ԡϹм۲ԡϹţм۲ԡϹм۲ԡʽͷʽͷ
	XTP_MARKET_TYPE         market;                                  ///< г

    int32_t                 leg_num;                                 ///< ɷֺԼ1-4ʵʴС
    XTPCombLegStrategy      leg_strategy[XTP_STRATEGE_LEG_NUM];      ///< ɷֺԼϢ

    XTP_EXPIRE_DATE_TYPE    expire_date_type;                        ///< ҪöֵΪͬգͬգ޵Ҫ
    XTP_UNDERLYING_TYPE     underlying_type;                         ///< ҪöֵΪͬģͬģޱҪ
    XTP_AUTO_SPLIT_TYPE     auto_sep_type;                           ///< Զ͡öֵΪ-1ã0Զ1E-1Զ

    uint64_t                reserved[10];                            ///< Ԥֶ
};

/// ϲȺԼϢṹ
typedef struct XTPOptCombLegInfo {
    char                            leg_security_id[XTP_TICKER_LEN]; ///< ɷֺԼ
    XTP_OPT_CALL_OR_PUT_TYPE        leg_cntr_type;                   ///< ԼͣϹϹ
    XTP_POSITION_DIRECTION_TYPE     leg_side;                        ///< ֲַȨ񷽡
    XTP_OPT_COVERED_OR_UNCOVERED    leg_covered;                     ///< ұǩ
    int32_t                         leg_qty;                         ///< ɷֺԼţ
}XTPOptCombLegInfo;

///ȨϲԱϢṹ
typedef struct XTPOptCombPlugin {
    char                                strategy_id[XTP_STRATEGY_ID_LEN];               ///< ϲԴ룬CNSJCϹţм۲Եȡ
    char                                comb_num[XTP_SECONDARY_ORDER_ID_LEN];           ///< ϱ룬걨ʱֶΪգ걨ʱдϵϱ롣
    int32_t                             num_legs;                                       ///< ɷֺԼ
    XTPOptCombLegInfo                   leg_detail[XTP_STRATEGE_LEG_NUM];               ///< ɷֺԼ飬ȡ
}XTPOptCombPlugin;

//////////////////////////////////////////////////////////////////////////
///ѯȨϲԳֲṹ
//////////////////////////////////////////////////////////////////////////
struct XTPQueryOptCombPositionReq
{
    ///ϱ
    char comb_num[XTP_SECONDARY_ORDER_ID_LEN];
    ///г
    XTP_MARKET_TYPE     market;
};


/// ѯȨϲԳֲϢӦ
struct XTPQueryOptCombPositionRsp {
    char                    strategy_id[XTP_STRATEGY_ID_LEN];           ///< ϲԴ
    char                    strategy_name[XTP_STRATEGY_NAME_LEN];       ///< ϲ
    
    XTP_MARKET_TYPE         market;                                     ///< г
    int64_t                 total_qty;                                  ///< ֲܳ
    int64_t                 available_qty;                              ///< ɲֲֳ
    int64_t                 yesterday_position;                         ///< ճֲ

    XTPOptCombPlugin        opt_comb_info;                              ///< ȨϲϢ

    uint64_t                reserved[50];                               ///< ֶ
};

/// ѯȨԼȨϢӦ
struct XTPQueryOptExecInfoRsp {
    XTP_MARKET_TYPE         market;                          ///< г
    char                    cntrt_code[XTP_TICKER_LEN];      ///< Լ

    int64_t                 own_qty_long;                    ///< Ȩ
    int64_t                 own_qty_short;                   ///< 
    int64_t                 own_qty_short_cover;             ///< 
    int64_t                 net_qty;                         ///< ͷ

    int64_t                 combed_qty_long;                 ///< Ȩ
    int64_t                 combed_qty_short;                ///< 
    int64_t                 combed_qty_short_cover;          ///< 

    int64_t                 total_execute_gene_order_qty;    ///< ۼͨȨί
    int64_t                 total_execute_gene_confirm_qty;  ///< ۼͨȨȷ
    int64_t                 total_execute_comb_order_qty;    ///< ۼȨϲί
    int64_t                 total_execute_comb_confirm_qty;  ///< ۼȨϲȷ

    uint64_t                reserved[50];                    ///< ֶ
};

//////////////////////////////////////////////////////////////////////////
///ѯȨȨϲͷṹ
//////////////////////////////////////////////////////////////////////////
struct XTPQueryOptCombExecPosReq
{
    ///г
    XTP_MARKET_TYPE market;
    ///ɷֺԼ1
    char cntrt_code_1[XTP_TICKER_LEN];
    ///ɷֺԼ2
    char cntrt_code_2[XTP_TICKER_LEN];

};

/// ѯȨȨϲͷӦ
struct XTPQueryOptCombExecPosRsp {

    XTP_MARKET_TYPE                 market;                             ///< г
    char                            cntrt_code_1[XTP_TICKER_LEN];       ///< ɷֺԼ1
    char                            cntrt_name_1[XTP_TICKER_NAME_LEN];  ///< ɷֺԼ1
    XTP_POSITION_DIRECTION_TYPE     position_side_1;                    ///< ɷֺԼ1ֲַ
    XTP_OPT_CALL_OR_PUT_TYPE        call_or_put_1;                      ///< ɷֺԼ1
    int64_t                         avl_qty_1;                          ///< ɷֺԼ1óֲ
    int64_t                         orig_own_qty_1;                     ///< ɷֺԼ1ճֲ
    int64_t                         own_qty_1;                          ///< ɷֺԼ1ǰֲ

    char                            cntrt_code_2[XTP_TICKER_LEN];       ///< ɷֺԼ2
    char                            cntrt_name_2[XTP_TICKER_NAME_LEN];  ///< ɷֺԼ2
    XTP_POSITION_DIRECTION_TYPE     position_side_2;                    ///< ɷֺԼ2ֲַ
    XTP_OPT_CALL_OR_PUT_TYPE        call_or_put_2;                      ///< ɷֺԼ2
    int64_t                         avl_qty_2;                          ///< ɷֺԼ2óֲ
    int64_t                         orig_own_qty_2;                     ///< ɷֺԼ2ճֲ
    int64_t                         own_qty_2;                          ///< ɷֺԼ2ǰֲ

    int64_t                         net_qty;                            ///< Ȩ־ͷ

    int64_t                         order_qty;                          ///< ȨϲίѾܵѳ
    int64_t                         confirm_qty;                        ///< Ȩϲȷ
    int64_t                         avl_qty;                            ///< Ȩϲ

    uint64_t                        reserved[49];                       ///< ֶ
};


//////////////////////////////////////////////////////////////////////////
///ȯֱӻӦϢ
//////////////////////////////////////////////////////////////////////////
struct XTPCrdCashRepayRsp
{
    int64_t xtp_id;             ///< ֱӻXTPID
    double  request_amount;     ///< ֱӻ
    double  cash_repay_amount;  ///< ʵʻʹý
};

//////////////////////////////////////////////////////////////////////////
///ȯֽϢӦϢ
//////////////////////////////////////////////////////////////////////////
struct XTPCrdCashRepayDebtInterestFeeRsp
{
	int64_t xtp_id;             ///< ֱӻXTPID
	double  request_amount;     ///< ֱӻ
	double  cash_repay_amount;  ///< ʵʻʹý
	char	debt_compact_id[XTP_CREDIT_DEBT_ID_LEN]; ///< ָĸծԼ
	char	unknow[32];			///< ֶ
};

//////////////////////////////////////////////////////////////////////////
///ȯֱӻ¼Ϣ
//////////////////////////////////////////////////////////////////////////
struct XTPCrdCashRepayInfo
{
    int64_t                     xtp_id;             ///< ֱӻXTPID
    XTP_CRD_CR_STATUS           status;             ///< ֱӻ״̬
    double                      request_amount;     ///< ֱӻ
    double                      cash_repay_amount;  ///< ʵʻʹý
    XTP_POSITION_EFFECT_TYPE    position_effect;    ///< ǿƽ־
	XTPRI						error_info;			///< ֱӻʱĴϢ
};

//////////////////////////////////////////////////////////////////////////
///ȯծ¼Ϣ
//////////////////////////////////////////////////////////////////////////
typedef struct XTPCrdDebtInfo
{
    int32_t             debt_type;              ///< ծԼͣ0Ϊʣ1Ϊȯ2δ֪
    char                debt_id[33];            ///< ծԼ
    int64_t             position_id;            ///< ծӦͷ
    uint64_t            order_xtp_id;           ///< ɸծĶţǵոծ޴
    int32_t             debt_status;            ///< ծԼ״̬0Ϊδ򲿷ֳ1Ϊѳ2Ϊδƽ֣3δ֪
    XTP_MARKET_TYPE     market;                 ///< г
    char                ticker[XTP_TICKER_LEN]; ///< ֤ȯ
    uint64_t            order_date;             ///< ί
    uint64_t            end_date;               ///< ծֹ
    uint64_t            orig_end_date;          ///< ծԭʼֹ
    bool                is_extended;            ///< ǷյչfalseΪûյtrueΪյ
    double              remain_amt;             ///< δ
    int64_t             remain_qty;             ///< δȯ
    double              remain_principal;       ///< δ
	int64_t				due_right_qty;			///< ӦȨ
	int64_t				unknown[2];				///< ֶ
}XTPCrdDebtInfo;

//////////////////////////////////////////////////////////////////////////
///ȯʻ
//////////////////////////////////////////////////////////////////////////
typedef struct XTPCrdFundInfo
{
    double maintenance_ratio;       ///< άֵƷ
    double all_asset;               ///< ʲ
    double all_debt;                ///< ܸծ
    double line_of_credit;          ///< Ŷ
    double guaranty;                ///< ڱ֤
    double reserved;                ///< ֶ
}XTPCrdFundInfo;

//////////////////////////////////////////////////////////////////////////
///ȯָ֤ȯϵĸծδṹ
//////////////////////////////////////////////////////////////////////////
typedef struct XTPClientQueryCrdDebtStockReq
{
    XTP_MARKET_TYPE market;                 ///< г
    char            ticker[XTP_TICKER_LEN]; ///< ֤ȯ
}XTPClientQueryCrdDebtStockReq;

//////////////////////////////////////////////////////////////////////////
///ȯָ֤ȯȯծϢ
//////////////////////////////////////////////////////////////////////////
typedef struct XTPCrdDebtStockInfo
{
    XTP_MARKET_TYPE market;                     ///< г
    char            ticker[XTP_TICKER_LEN];     ///< ֤ȯ
    int64_t         stock_repay_quantity;       ///< ȯծɻȯ
    int64_t         stock_total_quantity;       ///< ȯծδ
}XTPCrdDebtStockInfo;

//////////////////////////////////////////////////////////////////////////
///ȯͷ֤ȯѯṹ
//////////////////////////////////////////////////////////////////////////
typedef struct XTPClientQueryCrdPositionStockReq
{
    XTP_MARKET_TYPE market;                 ///< ֤ȯг
    char            ticker[XTP_TICKER_LEN]; ///< ֤ȯ
}XTPClientQueryCrdPositionStockReq;

//////////////////////////////////////////////////////////////////////////
///ȯͷ֤ȯϢ
//////////////////////////////////////////////////////////////////////////
typedef struct XTPClientQueryCrdPositionStkInfo 
{
    XTP_MARKET_TYPE market;                 ///< ֤ȯг
    char            ticker[XTP_TICKER_LEN]; ///< ֤ȯ
    int64_t         limit_qty;              ///< ȯ
    int64_t         yesterday_qty;          ///< ȯ
    int64_t         left_qty;               ///< ʣȯ
    int64_t         frozen_qty;             ///< ȯ
}XTPClientQueryCrdPositionStkInfo;


//////////////////////////////////////////////////////////////////////////
/// ҵȯѯṹ
//////////////////////////////////////////////////////////////////////////
typedef struct XTPClientQueryCrdSurplusStkReqInfo
{
    XTP_MARKET_TYPE market;                 ///< ֤ȯг
    char            ticker[XTP_TICKER_LEN]; ///< ֤ȯ
}XTPClientQueryCrdSurplusStkReqInfo;

//////////////////////////////////////////////////////////////////////////
///ҵȯϢ
//////////////////////////////////////////////////////////////////////////
typedef struct XTPClientQueryCrdSurplusStkRspInfo
{
    XTP_MARKET_TYPE market;                 ///< ֤ȯг
    char            ticker[XTP_TICKER_LEN]; ///< ֤ȯ
    int64_t         transferable_quantity;  ///< ɻת
    int64_t         transferred_quantity;   ///< ѻת
}XTPClientQueryCrdSurplusStkRspInfo;

///ûʽ˻ַ
#define XTP_ACCOUNT_PASSWORD_LEN 64  

/////////////////////////////////////////////////////////////////////////
///ûչ
/////////////////////////////////////////////////////////////////////////
struct XTPCreditDebtExtendReq
{
	uint64_t	xtpid;								///<xtpid
	char		debt_id[XTP_CREDIT_DEBT_ID_LEN];	///<ծԼ
	uint32_t	defer_days;							///<չ
	char        fund_account[XTP_ACCOUNT_NAME_LEN];	///<ʽ˺
	char	    password[XTP_ACCOUNT_PASSWORD_LEN];	///<ʽ˺
};

/////////////////////////////////////////////////////////////////////////
///ûչӦṹ
/////////////////////////////////////////////////////////////////////////
typedef struct XTPCreditDebtExtendNotice XTPCreditDebtExtendAck;


//////////////////////////////////////////////////////////////////////////
/// ȯʻϢ
//////////////////////////////////////////////////////////////////////////
typedef struct XTPCrdFundExtraInfo
{
    double    mf_rs_avl_used;  ///<ǰʽ˻һʹõȯʽռ
    char      reserve[64];     ///<Ԥռ
}XTPCrdFundExtraInfo;

//////////////////////////////////////////////////////////////////////////
///ȯʻֲָϢ
//////////////////////////////////////////////////////////////////////////
typedef struct XTPCrdPositionExtraInfo
{
    XTP_MARKET_TYPE market;                 ///<֤ȯг
    char            ticker[XTP_TICKER_LEN]; ///<֤ȯ
    double          mf_rs_avl_used;         ///<һʹõȯʽռ
    char            reserve[64];            ///<Ԥռ
}XTPCrdPositionExtraInfo;

///Ȩϲ¶
struct XTPOptCombOrderInsertInfo
{
    ///XTPϵͳIDûдXTPϵͳΨһ
    uint64_t                order_xtp_id;
    ///ãɿͻԶ
    uint32_t	            order_client_id;
    ///г
    XTP_MARKET_TYPE         market;
    ///(λΪ)
    int64_t                 quantity;

    ///Ϸ
    XTP_SIDE_TYPE           side;

    ///ҵ
    XTP_BUSINESS_TYPE       business_type;

    ///ȨϲϢ
    XTPOptCombPlugin        opt_comb_info;
};

///ȨϲԱӦṹ
struct XTPOptCombOrderInfo
{
    ///XTPϵͳIDXTPϵͳΨһ
    uint64_t                order_xtp_id;
    ///ãûԶ
    uint32_t	            order_client_id;
    ///ãûԶ壨δʹã
    uint32_t                order_cancel_client_id;
    ///XTPϵͳеidXTPϵͳΨһ
    uint64_t                order_cancel_xtp_id;
    ///֤ȯ
    ///char                    ticker[XTP_TICKER_LEN];
    ///г
    XTP_MARKET_TYPE         market;
    ///˶ı
    int64_t                 quantity;
    
    ///Ϸ
    XTP_SIDE_TYPE               side;
           
    ///ҵ
    XTP_BUSINESS_TYPE       business_type;
    ///ɽΪ˶ۼƳɽ
    int64_t                 qty_traded;
    ///ʣɹʱʾ
    int64_t                 qty_left;
    ///ίʱ䣬ʽΪYYYYMMDDHHMMSSsss
    int64_t                 insert_time;
    ///޸ʱ䣬ʽΪYYYYMMDDHHMMSSsss
    int64_t                 update_time;
    ///ʱ䣬ʽΪYYYYMMDDHHMMSSsss
    int64_t                 cancel_time;
    ///ɽϲ漰ı֤(ֶ)
    double                  trade_amount;
    ///ر OMSɵĵţͬorder_xtp_idΪ̵ĵ
    char                    order_local_id[XTP_LOCAL_ORDER_LEN];
    ///״̬Ӧûвֳɽ״̬ͣڲѯУвֳɽ״̬
    XTP_ORDER_STATUS_TYPE   order_status;
    ///ύ״̬ûôֳֶͱ
    XTP_ORDER_SUBMIT_STATUS_TYPE   order_submit_status;
    ///
    TXTPOrderTypeType       order_type;

    ///ȨϲϢ
    XTPOptCombPlugin        opt_comb_info;
};


///ȨϲԱɽṹ
struct XTPOptCombTradeReport
{
    ///XTPϵͳID˳ɽرصĶIDXTPϵͳΨһ
    uint64_t                 order_xtp_id;
    ///
    uint32_t                 order_client_id;
    ///г
    XTP_MARKET_TYPE          market;
    ///ţXTPID󣬸ֶʵʺorder_xtp_idظӿʱ
    uint64_t                 local_order_id;
    ///ɽţΨһϽÿʽΨһ2ʳɽرӵͬexec_idΪ˱ʽԳɽ
    char                     exec_id[XTP_EXEC_ID_LEN];
    ///˴γɽۼ
    int64_t                  quantity;
    ///ɽʱ䣬ʽΪYYYYMMDDHHMMSSsss
    int64_t                  trade_time;
    ///ɽϲ漰ı֤
    double                   trade_amount;
    ///ɽ --ر¼ţÿΨһ,report_index+marketֶοΨһʶʾɽر
    uint64_t                 report_index;
    /// --(ֶ)
    char                     order_exch_id[XTP_ORDER_EXCH_LEN];
    ///ɽ  --ɽرеִ
    TXTPTradeTypeType        trade_type;
    ///Ϸ
    XTP_SIDE_TYPE            side;
    ///ҵ
    XTP_BUSINESS_TYPE        business_type;
    ///Ա 
    char                     branch_pbu[XTP_BRANCH_PBU_LEN];

    ///ȨϲϢ
    XTPOptCombPlugin         opt_comb_info;
};


//////////////////////////////////////////////////////////////////////////
///ȨϲԱѯ
//////////////////////////////////////////////////////////////////////////
///ȨϲԱѯ-ѯ
struct XTPQueryOptCombOrderReq
{
    ///ϱ루ˮţΪգΪգĬϲѯʱڵгɽر
    char      comb_num[XTP_SECONDARY_ORDER_ID_LEN];
    ///ʽΪYYYYMMDDHHMMSSsssΪ0Ĭϵǰ0
    int64_t   begin_time;
    ///ʽΪYYYYMMDDHHMMSSsssΪ0Ĭϵǰʱ
    int64_t   end_time;
};

///ȨϲԱѯӦṹ
typedef struct XTPOptCombOrderInfo XTPQueryOptCombOrderRsp;

///ѯȨϲԶ-ҳѯ
struct XTPQueryOptCombOrderByPageReq
{
    ///ҪѯĶ
    int64_t         req_count;
    ///һյĲѯдǴͷѯ0
    int64_t         reference;
    ///ֶ
    int64_t         reserved;
};

//////////////////////////////////////////////////////////////////////////
///ȨϲԳɽرѯ
//////////////////////////////////////////////////////////////////////////
///ѯȨϲԳɽ-ִбŲѯֶΣ
struct XTPQueryOptCombReportByExecIdReq
{
    ///XTPϵͳID
    uint64_t  order_xtp_id;
    ///ɽִб
    char  exec_id[XTP_EXEC_ID_LEN];
};

///ѯȨϲԳɽر-ѯ
struct XTPQueryOptCombTraderReq
{
    ///ϱ루ˮţΪգΪգĬϲѯʱڵгɽر
    char      comb_num[XTP_SECONDARY_ORDER_ID_LEN];
    ///ʼʱ䣬ʽΪYYYYMMDDHHMMSSsssΪ0Ĭϵǰ0
    int64_t   begin_time;
    ///ʱ䣬ʽΪYYYYMMDDHHMMSSsssΪ0Ĭϵǰʱ
    int64_t   end_time;
};

///ɽرѯӦṹ
typedef struct XTPOptCombTradeReport  XTPQueryOptCombTradeRsp;

///ѯȨϲԳɽر-ҳѯ
struct XTPQueryOptCombTraderByPageReq
{
    ///Ҫѯĳɽر
    int64_t         req_count;
    ///һյĲѯɽرдǴͷѯ0
    int64_t         reference;
    ///ֶ
    int64_t         reserved;
};



#pragma pack()
#endif //_XOMS_API_STRUCT_H_

