/////////////////////////////////////////////////////////////////////////
///@author ̩֤ȯɷ޹˾
///@file xquote_api_struct.h
///@brief ݽṹ
/////////////////////////////////////////////////////////////////////////
#ifndef _XQUOTE_API_STRUCT_H_
#define _XQUOTE_API_STRUCT_H_

#include <stdint.h>
#include "xtp_api_data_type.h"

#pragma pack(8)

///ָĺԼ
typedef struct XTPSpecificTickerStruct
{
    ///
    XTP_EXCHANGE_TYPE exchange_id;
    ///Լ루Ϣ"600000"ո'\0'β
	char	ticker[XTP_TICKER_LEN];
} XTPST;

///Ʊծȯȶ
struct XTPMarketDataStockExData {
    ///ί(SH,SZ)
    int64_t total_bid_qty;
    ///ί(SH,SZ)
    int64_t total_ask_qty;
    ///Ȩƽί۸(SH,SZ)
    double ma_bid_price;
    ///Ȩƽί۸(SH,SZ)
    double ma_ask_price;
    ///ծȯȨƽί۸(SH)
    double ma_bond_bid_price;
    ///ծȯȨƽί۸(SH)
    double ma_bond_ask_price;
    ///ծȯ(SH)
    double yield_to_maturity;
    ///ʵʱοֵ(SH,SZ)
    double iopv;
    ///ETF깺(SH)
    int32_t etf_buy_count;
    ///ETFر(SH)
    int32_t etf_sell_count;
    ///ETF깺(SH)
    double etf_buy_qty;
    ///ETF깺(SH)
    double etf_buy_money;
    ///ETF(SH)
    double etf_sell_qty;
    ///ETFؽ(SH)
    double etf_sell_money;
    ///Ȩִ֤е(SH)
    double total_warrant_exec_qty;
    ///Ȩ֤ͣ۸Ԫ(SH)
    double warrant_lower_price;
    ///Ȩ֤ͣ۸Ԫ(SH)
    double warrant_upper_price;
    ///볷(SH)
    int32_t cancel_buy_count;
    ///(SH)
    int32_t cancel_sell_count;
    ///볷(SH)
    double cancel_buy_qty;
    ///(SH)
    double cancel_sell_qty;
    ///볷(SH)
    double cancel_buy_money;
    ///(SH)
    double cancel_sell_money;
    ///ܱ(SH)
    int64_t total_buy_count;
    ///ܱ(SH)
    int64_t total_sell_count;
    ///ίгɽȴʱ(SH)
    int32_t duration_after_buy;
    ///ίгɽȴʱ(SH)
    int32_t duration_after_sell;
    ///ίмλ(SH)
    int32_t num_bid_orders;
    ///ίмλ(SH)
    int32_t num_ask_orders;

    ///T-1վֵ(SZ)
    double pre_iopv;
    ///Ԥ
    int64_t r1;
    ///Ԥ
    int64_t r2;
};

/// Ȩ
struct XTPMarketDataOptionExData {
    ///жϲο(SH)
    double  auction_price;
    ///жϼϾƥ(SH)
    int64_t auction_qty;
    ///ѯʱ(SH)
    int64_t last_enquiry_time;
};

/////////////////////////////////////////////////////////////////////////
///@brief XTP_MARKETDATA_TYPE
/////////////////////////////////////////////////////////////////////////
enum XTP_MARKETDATA_TYPE {
    XTP_MARKETDATA_ACTUAL = 0, // ֻ(Ʊ//ծȯ)
    XTP_MARKETDATA_OPTION = 1, // Ȩ
};

///
typedef struct XTPMarketDataStruct
{
    // 
    ///
    XTP_EXCHANGE_TYPE exchange_id;
    ///Լ루Ϣո'\0'β
    char	ticker[XTP_TICKER_LEN];

    // ۸
	///¼
	double	last_price;
	///
	double	pre_close_price;
	///
	double	open_price;
	///߼
	double	high_price;
	///ͼ
	double	low_price;
    ///
    double	close_price;

    // Ȩ
    ///ճֲ()(Ŀǰδд)
    int64_t pre_total_long_positon;
    ///ֲ()
	int64_t	total_long_positon;
    ///ս
    double	pre_settl_price;
    ///ս
	double	settl_price;

	// ǵͣ
	///ͣ
	double	upper_limit_price;
	///ͣ
	double	lower_limit_price;
	///Ԥ
	double	pre_delta;
	///Ԥ
	double	curr_delta;

    /// ʱ࣬ʽΪYYYYMMDDHHMMSSsss
    int64_t data_time;

    // 
    ///Ϊܳɽλɣ뽻һ£
    int64_t	qty;
    ///ɽΪܳɽλԪ뽻һ£
    double	turnover;
    ///վ=(turnover/qty)
    double	avg_price;

    // 
    ///ʮ
    double bid[10];
    ///ʮ
    double	ask[10];
    ///ʮ
    int64_t	bid_qty[10];
    ///ʮ
    int64_t	ask_qty[10];

    // 
    ///ɽ
    int64_t trades_count;
    ///ǰ״̬˵ġXTP API.docĵ
    char ticker_status[8];
    ///
    union {
        XTPMarketDataStockExData  stk;
        XTPMarketDataOptionExData opt;
    };
    ///union
    XTP_MARKETDATA_TYPE data_type;
    ///Ԥ
    int32_t r4;
} XTPMD;


///Ʊ龲̬Ϣ
typedef struct XTPQuoteStaticInfo {
    ///
    XTP_EXCHANGE_TYPE exchange_id;
    ///Լ루Ϣո'\0'β
    char    ticker[XTP_TICKER_LEN];
    /// Լ
    char    ticker_name[XTP_TICKER_NAME_LEN];
    /// Լ
	XTP_TICKER_TYPE ticker_type;
    ///
    double  pre_close_price;
    ///ͣ
    double  upper_limit_price;
    ///ͣ
    double  lower_limit_price;
	///С䶯λ
	double  price_tick;
    /// ԼС()
    int32_t  buy_qty_unit;
    /// ԼС()
	int32_t sell_qty_unit;
} XTPQSI;


///
typedef struct OrderBookStruct {
    ///
    XTP_EXCHANGE_TYPE exchange_id;
    ///Լ루Ϣո'\0'β
    char    ticker[XTP_TICKER_LEN];

    ///¼
    double last_price;
    ///Ϊܳɽ
    int64_t qty;
    ///ɽΪܳɽ
    double  turnover;
    ///ɽ
    int64_t trades_count;

    // 
    ///ʮ
    double bid[10];
    ///ʮ
    double  ask[10];
    ///ʮ
    int64_t bid_qty[10];
    ///ʮ
    int64_t ask_qty[10];
    /// ʱ
    int64_t data_time;
} XTPOB;

////////////////////////////////// 


///ί()
struct XTPTickByTickEntrust {
    ///Ƶ
    int32_t channel_no;
    ///ί(ͬһchannel_noΨһ1ʼ)
    int64_t seq;
    ///ίм۸
    double  price;
    ///ί
    int64_t qty;
    ///'1':; '2':; 'G':; 'F':
    char  side;
    ///: '1': м; '2': ޼; 'U': 
    char ord_type;
};

///ʳɽ
struct XTPTickByTickTrade {
    ///Ƶ
    int32_t channel_no;
    ///ί(ͬһchannel_noΨһ1ʼ)
    int64_t seq;
    ///ɽ۸
    double price;
    ///ɽ
    int64_t qty;
    ///ɽ(Ͻ)
    double money;
    ///򷽶
    int64_t bid_no;
    ///
    int64_t ask_no;
    /// SH: ̱ʶ('B':; 'S':; 'N':δ֪)
    /// SZ: ɽʶ('4':; 'F':ɽ)
    char trade_flag;
};

///Ϣ
typedef struct XTPTickByTickStruct {
    ///
    XTP_EXCHANGE_TYPE exchange_id;
    ///Լ루Ϣո'\0'β
    char ticker[XTP_TICKER_LEN];
    ///Ԥ
    int64_t seq;
    ///ίʱ or ɽʱ
    int64_t data_time;
    ///ί or ɽ
    XTP_TBT_TYPE type;

    union {
        XTPTickByTickEntrust entrust;
        XTPTickByTickTrade     trade;
    };
} XTPTBT;


///ѯϢ
typedef struct XTPTickerPriceInfo {
    ///
    XTP_EXCHANGE_TYPE exchange_id;
    ///Լ루Ϣո'\0'β
    char ticker[XTP_TICKER_LEN];
    ///¼
    double last_price;
} XTPTPI;

///Ʊȫ̬Ϣ
typedef struct XTPQuoteFullInfo {
	XTP_EXCHANGE_TYPE  exchange_id;							///<
	char               ticker[XTP_TICKER_LEN];				///<֤ȯ
	char               ticker_name[XTP_TICKER_NAME_LEN];	///<֤ȯ
	XTP_SECURITY_TYPE      security_type;					///<Լϸ
	XTP_QUALIFICATION_TYPE ticker_qualification_class;		///<Լʵ
	bool is_registration;									///<Ƿע(ôҵƱҵƱƾ֤)
	bool is_VIE;											///<ǷЭƼܹ(ôҵƱҵƱƾ֤)
	bool is_noprofit;										///<Ƿδӯ(ôҵƱҵƱƾ֤)
	bool is_weighted_voting_rights;							///<ǷͶƱȨ(ôҵƱҵƱƾ֤)
	bool is_have_price_limit;								///<Ƿǵ(עṩȣͨǵͣۺռ)
	double upper_limit_price;								///<ۣͣǵʱЧ
	double lower_limit_price;								///<ۣͣǵʱЧ
	double pre_close_price;									///<ռ
	double price_tick;										///<۸С䶯λ
	int32_t bid_qty_upper_limit;							///<޼ί
	int32_t bid_qty_lower_limit;							///<޼ί
	int32_t bid_qty_unit;									///<޼λ
	int32_t ask_qty_upper_limit;							///<޼ί
	int32_t ask_qty_lower_limit;							///<޼ί
	int32_t ask_qty_unit;									///<޼λ
	int32_t market_bid_qty_upper_limit;						///<мί
	int32_t market_bid_qty_lower_limit;						///<мί
	int32_t market_bid_qty_unit;							///<мλ
	int32_t market_ask_qty_upper_limit;						///<мί
	int32_t market_ask_qty_lower_limit;						///<мί
	int32_t market_ask_qty_unit;							///<мλ
	uint64_t unknown[4];									///<ֶ
}XTPQFI;

#pragma pack()

#endif
